diff --git a/logview/logview.c b/logview/logview.c
index d1bdbaa..91ce390 100644
--- a/logview/logview.c
+++ b/logview/logview.c
@@ -1,22 +1,22 @@
 /*  ----------------------------------------------------------------------
 
-    Copyright (C) 1998  Cesar Miquel  (miquel@df.uba.ar)
+Copyright (C) 1998  Cesar Miquel  (miquel@df.uba.ar)
 
-    This program is free software; you can redistribute it and/or modify
-    it under the terms of the GNU General Public License as published by
-    the Free Software Foundation; either version 2 of the License, or
-    (at your option) any later version.
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
 
-    This program is distributed in the hope that it will be useful,
-    but WITHOUT ANY WARRANTY; without even the implied warranty of
-    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-    GNU General Public License for more details.
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
 
-    You should have received a copy of the GNU General Public License
-    along with this program; if not, write to the Free Software
-    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 
-    ---------------------------------------------------------------------- */
+---------------------------------------------------------------------- */
 
 #include <config.h>
 #include <stdlib.h>
@@ -33,19 +33,21 @@
 #include "logview-findbar.h"
 #include "userprefs.h"
 #include "calendar.h"
+#include "logview-debug.h"
+#include "logview-plugin-manager.h"
 
 #define APP_NAME _("System Log Viewer")
 
 enum {
-  PROP_0,
-  PROP_DAYS,
+	PROP_0,
+	PROP_DAYS,
 };
 
 enum {
-  LOG_LINE_TEXT = 0,
-  LOG_LINE_POINTER,
-  LOG_LINE_WEIGHT,
-  LOG_LINE_WEIGHT_SET
+	LOG_LINE_TEXT = 0,
+	LOG_LINE_POINTER,
+	LOG_LINE_WEIGHT1,
+	LOG_LINE_WEIGHT_SET1
 };
 
 static GObjectClass *parent_class;
@@ -76,8 +78,7 @@ static void logview_help (GtkAction *action, GtkWidget *parent_window);
 static void logview_copy (GtkAction *action, LogviewWindow *logview);
 static void logview_select_all (GtkAction *action, LogviewWindow *logview);
 static Log *logview_find_log_from_name (LogviewWindow *logview, gchar *name);
-
-static void logview_window_get_property	(GObject *object, guint param_id, GValue *value, GParamSpec *pspec);
+static void logview_plugin_dialog_show (GtkAction *action, LogviewWindow *logview);
 
 /* Menus */
 
@@ -115,14 +116,16 @@ static GtkActionEntry entries[] = {
 	  G_CALLBACK (logview_help) },
 	{ "AboutAction", GTK_STOCK_ABOUT, N_("_About"), NULL, N_("Show the about dialog for the log viewer"), 
 	  G_CALLBACK (logview_about) },
+	{ "PluginList", NULL, N_("_Plugins"), NULL, N_("Show the information of the loaded plugins"), 
+	  G_CALLBACK (logview_plugin_dialog_show) },
 
 };
 
 static GtkToggleActionEntry toggle_entries[] = {
-    { "ShowStatusBar", NULL, N_("_Statusbar"), NULL, N_("Show Status Bar"),
-      G_CALLBACK (logview_toggle_statusbar), TRUE },
+	{ "ShowStatusBar", NULL, N_("_Statusbar"), NULL, N_("Show Status Bar"),
+	  G_CALLBACK (logview_toggle_statusbar), TRUE },
 	{ "ShowSidebar", NULL, N_("Side _Pane"), "F9", N_("Show Side Pane"), 
-		G_CALLBACK (logview_toggle_sidebar), TRUE },
+	  G_CALLBACK (logview_toggle_sidebar), TRUE },
 	{ "MonitorLogs", NULL, N_("_Monitor"), "<control>M", N_("Monitor Current Log"),
 	  G_CALLBACK (logview_toggle_monitor), TRUE },
 	{"ShowCalendar", NULL,  N_("Ca_lendar"), "<control>L", N_("Show Calendar Log"), 
@@ -130,202 +133,240 @@ static GtkToggleActionEntry toggle_entries[] = {
 };
 
 static const char *ui_description = 
-	"<ui>"
-	"	<menubar name='LogviewMenu'>"
-	"		<menu action='FileMenu'>"
-	"			<menuitem action='OpenLog'/>"
-	"			<menuitem action='CloseLog'/>"
-	"			<menuitem action='Quit'/>"
-	"		</menu>"
-	"		<menu action='EditMenu'>"
-	"			<menuitem action='Copy'/>"
-	"	    	<menuitem action='SelectAll'/>"
-	"		</menu>"
-	"		<menu action='ViewMenu'>"
-	"			<menuitem action='MonitorLogs'/>"
-	"			<separator/>"
-	"			<menuitem action='ShowStatusBar'/>"
-	"			<menuitem action='ShowSidebar'/>"
-	"			<menuitem action='ShowCalendar'/>"
-	"			<separator/>"
-	"			<menuitem action='Search'/>"
-	"			<menuitem action='CollapseAll'/>"
-	"			<separator/>"
-	"			<menuitem action='ViewZoomIn'/>"
-	"			<menuitem action='ViewZoomOut'/>"
-	"			<menuitem action='ViewZoom100'/>"
-	"		</menu>"
-	"		<menu action='HelpMenu'>"
-	"			<menuitem action='HelpContents'/>"
-	"			<menuitem action='AboutAction'/>"
-	"		</menu>"
-	"	</menubar>"
-	"</ui>";
+"<ui>"
+"	<menubar name='LogviewMenu'>"
+"		<menu action='FileMenu'>"
+"			<menuitem action='OpenLog'/>"
+"			<menuitem action='CloseLog'/>"
+"			<menuitem action='Quit'/>"
+"		</menu>"
+"		<menu action='EditMenu'>"
+"			<menuitem action='Copy'/>"
+"	    	<menuitem action='SelectAll'/>"
+"		</menu>"
+"		<menu action='ViewMenu'>"
+"			<menuitem action='MonitorLogs'/>"
+"			<separator/>"
+"			<menuitem action='ShowStatusBar'/>"
+"			<menuitem action='ShowSidebar'/>"
+"			<menuitem action='ShowCalendar'/>"
+"			<separator/>"
+"			<menuitem action='Search'/>"
+"			<menuitem action='CollapseAll'/>"
+"			<separator/>"
+"			<menuitem action='ViewZoomIn'/>"
+"			<menuitem action='ViewZoomOut'/>"
+"			<menuitem action='ViewZoom100'/>"
+"			<separator/>"
+"			<menuitem action='PluginList'/>"
+"		</menu>"
+"		<menu action='HelpMenu'>"
+"			<menuitem action='HelpContents'/>"
+"			<menuitem action='AboutAction'/>"
+"		</menu>"
+"	</menubar>"
+"</ui>";
 
 /* public interface */
 
 Log *
 logview_get_active_log (LogviewWindow *logview)
 {
-    g_return_val_if_fail (LOGVIEW_IS_WINDOW (logview), NULL);
-    return logview->curlog;
+	g_return_val_if_fail (LOGVIEW_IS_WINDOW (logview), NULL);
+	return logview->curlog;
 }
 
 LogList *
 logview_get_loglist (LogviewWindow *logview)
 {
-    g_return_val_if_fail (LOGVIEW_IS_WINDOW (logview), NULL);
-    return LOG_LIST (logview->loglist);
+	g_return_val_if_fail (LOGVIEW_IS_WINDOW (logview), NULL);
+	return LOG_LIST (logview->loglist);
 }
 
 int
 logview_count_logs (LogviewWindow *logview)
 {
-    g_assert (LOGVIEW_IS_WINDOW (logview));
-    return g_slist_length (logview->logs);
+	g_assert (LOGVIEW_IS_WINDOW (logview));
+	return g_slist_length (logview->logs);
 }
 
 static void
 logview_store_visible_range (LogviewWindow *logview)
 {
-  GtkTreePath *first, *last;
-  Log *log = logview->curlog;
-  if (log == NULL)
-    return;
+	GtkTreePath *first = NULL;
+	Log *log = logview->curlog;
+	if (log == NULL)
+		return;
 
-  if (log->visible_first)
-    gtk_tree_path_free (log->visible_first);
+	if (gtk_tree_view_get_visible_range (GTK_TREE_VIEW (logview->view),
+					     &first, NULL))
+		g_object_set (G_OBJECT (log), "visible-first", first, NULL);
+}
 
-  if (gtk_tree_view_get_visible_range (GTK_TREE_VIEW (logview->view),
-                                       &first, NULL))
-    log->visible_first = first;
+static void
+logview_update_other_components (LogviewWindow *logview)
+{
+	logview_set_window_title (logview);
+	logview_menus_set_state (logview);
+	logview_calendar_set_state (logview);
+	logview_repaint (logview);
+	logview_update_findbar_visibility (logview);
 }
 
 void
 logview_select_log (LogviewWindow *logview, Log *log)
 {
-    g_return_if_fail (LOGVIEW_IS_WINDOW (logview));
+	LV_MARK;
+	g_return_if_fail (LOGVIEW_IS_WINDOW (logview));
+	if (!GTK_WIDGET_VISIBLE (GTK_WIDGET (logview->view)))
+		return;
   
-    logview_store_visible_range (logview);
-
-    logview->curlog = log;
-    logview_menus_set_state (logview);
-    logview_calendar_set_state (logview);
-    logview_repaint (logview);
-    logview_update_findbar_visibility (logview);
-    
-    logview_update_version_bar (logview);
-    logview_save_prefs (logview); 
-    gtk_widget_grab_focus (logview->view);
-} 
+	logview_store_visible_range (logview);
+
+	logview->curlog = log;
+	/* 
+	   update version bar first, because the user may choose a child log
+	   of logview->curlog, so to avoid update other components multi times
+	   give the update responsibility to the change signal of version bar.
+
+	   Note that if choose a log path, then blank out all the Gui.
+	*/
+	logview_update_version_bar (logview);
+	if (logview->curlog == NULL) {
+		logview_update_other_components (logview);
+	}
+	gtk_widget_grab_focus (logview->view);
+}
 
 void
 logview_add_log_from_name (LogviewWindow *logview, gchar *file)
 {
 	Log *log;
 
-    g_return_if_fail (LOGVIEW_IS_WINDOW (logview));
-    g_return_if_fail (file);
+	g_return_if_fail (LOGVIEW_IS_WINDOW (logview));
+	g_return_if_fail (file);
 
-    log = log_open (file, TRUE);
-    if (log != NULL)
-      logview_add_log (logview, log);
+	log = pluginmgr_new_log_from_path (file);
+	if (log != NULL)
+		logview_add_log (logview, log);
+	else
+		error_dialog_show (NULL, _("Add log error."), log_error());
 }
 
 void
 logview_add_logs_from_names (LogviewWindow *logview, GSList *lognames, gchar *selected)
 {
-    GSList *list;
-    Log *log, *curlog = NULL;
+	GSList *list;
+	Log *log, *curlog = NULL;
+	gchar *log_name;
 	
-    g_return_if_fail (LOGVIEW_IS_WINDOW (logview));
-
-    if (lognames == NULL)
-        return;
-
-    for (list = lognames; list != NULL; list = g_slist_next (list)) {
-      log = log_open (list->data, FALSE);
-      if (log != NULL) {
-	logview_add_log (logview, log);
-	if (selected!=NULL && g_strncasecmp (log->name, selected, -1)==0)
-	  curlog = log;
-      }
-    }
+	g_return_if_fail (LOGVIEW_IS_WINDOW (logview));
+
+	if (lognames == NULL)
+		return;
+
+	/* remove log_open, open by pluginmgr_get_all_logs or loglist? */
+	for (list = lognames; list != NULL; list = g_slist_next (list)) {
+		log = pluginmgr_new_log_from_path ((gchar*)list->data);
+		if (log != NULL) {
+			logview_add_log (logview, log);
+			g_object_get (G_OBJECT (log), "path", &log_name, NULL);
+			if (selected!=NULL && 
+			    (g_strncasecmp (log_name, selected, -1) == 0))
+				curlog = log;
+			g_free (log_name);
+		}
+		else
+			error_dialog_show (NULL, _("Add log error."), log_error());
+	}
         
-    if (curlog)
-        loglist_select_log (LOG_LIST (logview->loglist), curlog);
+	if (curlog)
+		loglist_select_log (LOG_LIST (logview->loglist), curlog);
 
-    gtk_tree_view_expand_all (GTK_TREE_VIEW (logview->loglist));
+	gtk_tree_view_expand_all (GTK_TREE_VIEW (logview->loglist));
 }
 
 void
 logview_menus_set_state (LogviewWindow *logview)
 {
-    Log *log;
-    gboolean calendar_active = FALSE, monitor_active = FALSE;
-    GtkWidget *widget;
-
-    g_assert (LOGVIEW_IS_WINDOW (logview));
-    log = logview->curlog;
-
-    if (log) {
-        monitor_active = (log->display_name == NULL);
-        calendar_active = (log->days != NULL);
-        logview_menu_item_toggle_set_active (logview, "/LogviewMenu/ViewMenu/MonitorLogs", logview->curlog->monitored);
-    }
+	Log *log;
+	gboolean monitorable;
+	gboolean monitoring;
+	gboolean groupable;
+	gboolean calendar_active = FALSE, monitor_active = FALSE;
+
+	g_assert (LOGVIEW_IS_WINDOW (logview));
+	log = logview->curlog;
+	if (log) {
+		g_assert (LOGVIEW_IS_LOG (log));
+		g_object_get (G_OBJECT (log),
+			      "monitorable", &monitorable,
+			      "monitoring", &monitoring,
+			      "groupable", &groupable,
+			      NULL);
+
+		monitor_active = monitorable;
+		calendar_active = groupable;
+		logview_menu_item_toggle_set_active (logview,
+						     "/LogviewMenu/ViewMenu/MonitorLogs",
+						     monitoring);
+	}
     
-    logview_menu_item_set_state (logview, "/LogviewMenu/ViewMenu/MonitorLogs", monitor_active);
-    logview_menu_item_set_state (logview, "/LogviewMenu/ViewMenu/ShowCalendar", calendar_active);
-    logview_menu_item_set_state (logview, "/LogviewMenu/FileMenu/CloseLog", (log != NULL));
-    logview_menu_item_set_state (logview, "/LogviewMenu/ViewMenu/CollapseAll", calendar_active);
-    logview_menu_item_set_state (logview, "/LogviewMenu/ViewMenu/Search", (log != NULL));
-    logview_menu_item_set_state (logview, "/LogviewMenu/EditMenu/Copy", (log != NULL));
-    logview_menu_item_set_state (logview, "/LogviewMenu/EditMenu/SelectAll", (log != NULL));
+	logview_menu_item_set_state (logview, "/LogviewMenu/ViewMenu/MonitorLogs", monitor_active);
+	logview_menu_item_set_state (logview, "/LogviewMenu/ViewMenu/ShowCalendar", calendar_active);
+	logview_menu_item_set_state (logview, "/LogviewMenu/FileMenu/CloseLog", (log != NULL));
+	logview_menu_item_set_state (logview, "/LogviewMenu/ViewMenu/CollapseAll", calendar_active);
+	logview_menu_item_set_state (logview, "/LogviewMenu/ViewMenu/Search", (log != NULL));
+	logview_menu_item_set_state (logview, "/LogviewMenu/EditMenu/Copy", (log != NULL));
+	logview_menu_item_set_state (logview, "/LogviewMenu/EditMenu/SelectAll", (log != NULL));
 }
 
 void
 logview_set_window_title (LogviewWindow *logview)
 {
-    gchar *window_title;
-    gchar *logname;
-    Log *log;
-
-    g_assert (LOGVIEW_IS_WINDOW (logview));
-
-    log = logview->curlog;
-    if (log == NULL)
-      return;
-
-    if (log->name != NULL) {
-
-      if (log->display_name != NULL)
-	logname = log->display_name;
-      else
-	logname = log->name;
-      
-      if (log->monitored) 
-	window_title = g_strdup_printf (_("%s (monitored) - %s"), logname, APP_NAME);
-      else
-	window_title = g_strdup_printf ("%s - %s", logname, APP_NAME);
-
-    }
-    else
-      window_title = g_strdup_printf (APP_NAME);
-
-    gtk_window_set_title (GTK_WINDOW (logview), window_title);
-    g_free (window_title);
+	gchar *window_title;
+	gchar *logname;
+	gboolean monitoring;
+	Log *log;
+
+	g_assert (LOGVIEW_IS_WINDOW (logview));
+
+	log = logview->curlog;
+	logname = NULL;
+
+	if (log != NULL) {
+		g_object_get (G_OBJECT (log),
+			      "display-name", &logname,
+			      "monitoring", &monitoring,
+			      NULL);
+		if (logname == NULL) {
+			g_object_get (G_OBJECT (log),
+				      "path", &logname,
+				      NULL);
+		}
+		if (monitoring)
+			window_title = g_strdup_printf (_("%s (monitored) - %s"), logname, APP_NAME);
+		else
+			window_title = g_strdup_printf (_("%s - %s"), logname, APP_NAME);
+	}
+	else
+		window_title = g_strdup_printf (APP_NAME);
+
+	gtk_window_set_title (GTK_WINDOW (logview), window_title);
+	g_free (window_title);
+	g_free (logname);
 }
 
 void
 logview_show_main_content (LogviewWindow *logview)
 {
-  g_return_if_fail (LOGVIEW_IS_WINDOW (logview));
-  gtk_widget_show (logview->calendar);
-  gtk_widget_show (logview->loglist);
-  gtk_widget_show (logview->sidebar);
-  gtk_widget_show (logview->view);
-  gtk_widget_show (logview->hpaned);
-  gtk_widget_show (logview->statusbar);
+	g_return_if_fail (LOGVIEW_IS_WINDOW (logview));
+	gtk_widget_show (logview->calendar);
+	gtk_widget_show (logview->loglist);
+	gtk_widget_show (logview->sidebar);
+	gtk_widget_show (logview->view);
+	gtk_widget_show (logview->hpaned);
+	gtk_widget_show (logview->statusbar);
 }
 
 /* private functions */
@@ -334,12 +375,18 @@ static void
 logview_update_findbar_visibility (LogviewWindow *logview)
 {
 	Log *log = logview->curlog;
-    if (log == NULL) {
-        gtk_widget_hide (logview->find_bar);
-        return;
-    }
+	GtkTreeModelFilter *filter;
+
+	if (log == NULL) {
+		gtk_widget_hide (logview->find_bar);
+		return;
+	}
+
+	g_object_get (G_OBJECT (log),
+		      "filter", &filter,
+		      NULL);
 
-	if (log->filter != NULL)
+	if (filter != NULL)
 		gtk_widget_show (logview->find_bar);
 	else
 		gtk_widget_hide (logview->find_bar);
@@ -348,208 +395,279 @@ logview_update_findbar_visibility (LogviewWindow *logview)
 static void
 logview_save_prefs (LogviewWindow *logview)
 {
-    GSList *list;
-    Log *log;
+	GSList *list;
+	Log *log, *parent;
 
-    g_return_if_fail (LOGVIEW_IS_WINDOW (logview));
+	LV_MARK;
+	g_return_if_fail (LOGVIEW_IS_WINDOW (logview));
 
-    if (GTK_WIDGET_VISIBLE (GTK_WIDGET (logview->loglist))) {
-        prefs_free_loglist();
-        for (list = logview->logs; list != NULL; list = g_slist_next (list)) {
-            log = list->data;
-            prefs_store_log (log->name);
-        }
+	if (GTK_WIDGET_VISIBLE (GTK_WIDGET (logview->loglist))) {
+		prefs_free_loglist();
+		for (list = logview->logs; list != NULL; list = g_slist_next (list)) {
+			gchar *name = NULL;
+			g_assert (LOGVIEW_IS_LOG (list->data));
+			log = LOGVIEW_LOG (list->data);
+			g_object_get (G_OBJECT (log), "path", &name, NULL);
+			prefs_store_log (name);
+			g_free (name);
+		}
         
-        if (logview->curlog) {
-	  if (logview->curlog->parent_log)
-            prefs_store_active_log (logview->curlog->parent_log->name);
-	  else
-	    prefs_store_active_log (logview->curlog->name);
+		if (logview->curlog) {
+			gchar *log_name, *parent_name;
+			log_name = parent_name = NULL;
+			g_assert (LOGVIEW_IS_LOG (logview->curlog));
+			g_object_get (G_OBJECT (logview->curlog),
+				      "path", &log_name,
+				      "parent", &parent,
+				      NULL);
+			if (parent) {
+				g_assert (LOGVIEW_IS_LOG (parent));
+				g_object_get (G_OBJECT (parent),
+					      "path", &parent_name,
+					      NULL);
+				prefs_store_active_log (parent_name);
+				g_free (parent_name);
+			}
+			else {
+				prefs_store_active_log (log_name);
+			}
+			g_free (log_name);
+		}
+		prefs_store_fontsize (logview->fontsize);
+		prefs_save ();
 	}
-        prefs_store_fontsize (logview->fontsize);
-	prefs_save ();
-    }
 }
 
 static void
 logview_destroy (GObject *object, LogviewWindow *logview)
 {
-    g_assert (LOGVIEW_IS_WINDOW (logview));
-
-    if (logview->curlog) {
-        if (logview->curlog->monitored)
-            monitor_stop (logview->curlog);
-    }
+	GSList* idx;
+	gboolean monitoring;
+	g_assert (LOGVIEW_IS_WINDOW (logview));
+	LV_MARK;
+
+	if (logview->curlog) {
+		g_object_get (G_OBJECT (logview->curlog), "monitoring", &monitoring, NULL);
+		if (monitoring)
+			monitor_stop (logview->curlog);
+	}
 
-    logview_save_prefs (logview);
-    prefs_free_loglist ();
+	logview_save_prefs (logview);
+	prefs_free_loglist();
+
+	logview_select_log (logview, NULL);
+	for (idx = logview->logs; idx != NULL; idx = idx->next) {
+		Log *log;
+		g_assert (LOGVIEW_IS_LOG (idx->data));
+		log = LOGVIEW_LOG (idx->data);
+		g_object_get (G_OBJECT (log), "monitoring", &monitoring, NULL);
+		if (monitoring)
+			monitor_stop (log);
+	}
+	g_slist_foreach (logview->logs, (GFunc) g_object_unref, NULL);
+	g_slist_free (logview->logs);
 
-    if (gtk_main_level() > 0)
-      gtk_main_quit ();
-    else
-      exit (0);
+	if (gtk_main_level() > 0)
+		gtk_main_quit ();
+	else {
+		pluginmgr_destroy ();
+		logview_debug_destroy ();
+		exit (0);
+	}
 }
 
 static void
 logview_add_log (LogviewWindow *logview, Log *log)
 {
-    g_return_if_fail (LOGVIEW_IS_WINDOW (logview));
-    g_return_if_fail (log);
+	g_return_if_fail (LOGVIEW_IS_WINDOW (logview));
+	g_return_if_fail (log);
 
-    logview->logs = g_slist_append (logview->logs, log);
-    loglist_add_log (LOG_LIST(logview->loglist), log);
-    log->window = logview;
-    monitor_start (log);
+	logview->logs = g_slist_append (logview->logs, log);
+	loglist_add_log (LOG_LIST(logview->loglist), log);
+	g_object_set (G_OBJECT (log), "view", logview->view, NULL);
+	monitor_start (log);
+	logview_select_log (logview, log);
 }
 
 
 static Log *
 logview_find_log_from_name (LogviewWindow *logview, gchar *name)
 {
-  GSList *list;
-  Log *log;
-
-  if (logview == NULL || name == NULL)
-      return NULL;
-
-  for (list = logview->logs; list != NULL; list = g_slist_next (list)) {
-    log = list->data;
-    if (g_ascii_strncasecmp (log->name, name, 255) == 0) {
-      return log;
-    }
-  }
-  return NULL;
+	GSList *list;
+	Log *log;
+
+	if (logview == NULL || name == NULL)
+		return NULL;
+
+	for (list = logview->logs; list != NULL; list = g_slist_next (list)) {
+		gchar *log_name;
+		log = list->data;
+		g_object_get (G_OBJECT (log), "path", &log_name, NULL);
+		if (g_ascii_strncasecmp (log_name , name, 255) == 0) {
+			g_free (log_name);
+			return log;
+		}
+		g_free (log_name);
+	}
+	return NULL;
 }
 
 static void
 logview_version_selector_changed (GtkComboBox *version_selector, gpointer user_data)
 {
 	LogviewWindow *logview = user_data;
-	Log *log = logview->curlog;
-	int selected;
+	Log *log, **old_logs;
+	int selected, archive_id, current_version, versions;
+	gchar *archive_n = NULL;
 
-    g_assert (LOGVIEW_IS_WINDOW (logview));
+	g_assert (LOGVIEW_IS_WINDOW (logview));
+	if (logview->curlog == NULL)
+		return;
+	g_assert (LOGVIEW_IS_LOG (logview->curlog));
+	/* first, get the parent log */
+	g_object_get (G_OBJECT (logview->curlog),
+		      "parent", &log,
+		      NULL);
+	if (log == NULL)
+		log = logview->curlog;
+	g_object_get (G_OBJECT (log),
+		      "archives", &old_logs,
+		      "current-version", &current_version,
+		      NULL);
 
 	selected = gtk_combo_box_get_active (version_selector);
-
-	if (selected == log->current_version)
-		return;
+	/* return if already selected and 
+	   recorded pointer is equal to the current log or child log */
+	if (selected > 0) {
+		archive_n = gtk_combo_box_get_active_text (version_selector);
+		sscanf (archive_n, "%*s%d", &archive_id);
+		g_free (archive_n);
+	}
 
 	/* select a new version */
-	if (selected == 0) {
-		logview_select_log (logview, log->parent_log);
+	if (selected >= 0)
+		g_object_set (G_OBJECT (log),
+			      "current-version", selected,
+			      NULL);
+	if (selected <= 0) {
+		logview->curlog = log;
 	} else {
-		Log *new;
-		if (log->parent_log) {
-			new = log->parent_log->older_logs[selected];
-		} else {
-			new = log->older_logs[selected];
-		}
-
-		logview_select_log (logview, new);
+		logview->curlog = old_logs[archive_id];
 	}
+	/* must update the gui due to currently log is switched */
+	logview_update_other_components (logview);
 }
 
 static void
 logview_close_log (GtkAction *action, LogviewWindow *logview)
 {
-    Log *log;
-    g_assert (LOGVIEW_IS_WINDOW (logview));
+	Log *log;
+	gboolean monitoring;
+	LV_MARK;
+	g_assert (LOGVIEW_IS_WINDOW (logview));
 
-    if (logview->curlog == NULL)
-        return;
+	if (logview->curlog == NULL)
+		return;
 
-    if (logview->curlog->monitored) {
-        GtkAction *action = gtk_ui_manager_get_action (logview->ui_manager, "/LogviewMenu/ViewMenu/MonitorLogs");
-        gtk_action_activate (action);
-    }
+	g_object_get (G_OBJECT (logview->curlog), "monitoring", &monitoring, NULL);
+	if (monitoring) {
+		GtkAction *action = gtk_ui_manager_get_action (logview->ui_manager, "/LogviewMenu/ViewMenu/MonitorLogs");
+		gtk_action_activate (action);
+	}
     
-    gtk_widget_hide (logview->find_bar);
+	gtk_widget_hide (logview->find_bar);
 
-    log = logview->curlog;
-    logview->curlog = NULL;
+	/* loglist can only remove parent log */
+	g_object_get (G_OBJECT (logview->curlog), "parent", &log, NULL);
+	if (log ==  NULL)
+		log = logview->curlog;
+	logview->curlog = NULL;
 
-    logview->logs = g_slist_remove (logview->logs, log);
-    log_close (log);
-    loglist_remove_log (LOG_LIST (logview->loglist), log);
+	logview->logs = g_slist_remove (logview->logs, log);
+	loglist_remove_log (LOG_LIST (logview->loglist), log);
+	g_object_unref (log);
 }
 
 static void
 logview_file_selected_cb (GtkWidget *chooser, gint response, LogviewWindow *logview)
 {
-   char *f;
+	char *f;
 
-   g_assert (LOGVIEW_IS_WINDOW (logview));
+	g_assert (LOGVIEW_IS_WINDOW (logview));
 
-   gtk_widget_hide (GTK_WIDGET (chooser));
-   if (response != GTK_RESPONSE_OK)
-	   return;
-   
-   f = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (chooser));
-
-   if (f != NULL) {
-       /* Check if the log is not already opened */
-       GSList *list;
-       Log *log, *tl;
-	   for (list = logview->logs; list != NULL; list = g_slist_next (list)) {
-		   log = list->data;
-		   if (g_ascii_strncasecmp (log->name, f, 255) == 0) {
-		     loglist_select_log (LOG_LIST (logview->loglist), log);
-		     return;
-		   }
-	   }
-
-	   if ((tl = log_open (f, TRUE)) != NULL)
-	     logview_add_log (logview, tl);
-   }
+	gtk_widget_hide (GTK_WIDGET (chooser));
+	if (response != GTK_RESPONSE_OK)
+		return;
    
-   g_free (f);
+	f = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (chooser));
+
+	if (f != NULL) {
+		/* Check if the log is not already opened */
+		GSList *list;
+		Log *log, *tl;
+		for (list = logview->logs; list != NULL; list = g_slist_next (list)) {
+			gchar *log_name;
+			log = list->data;
+			g_object_get (G_OBJECT (log), "path", &log_name, NULL);
+			if (g_ascii_strncasecmp (log_name, f, 255) == 0) {
+				loglist_select_log (LOG_LIST (logview->loglist), log);
+				g_free (log_name);
+				return;
+			}
+			g_free (log_name);
+		}
 
+		if ((tl = pluginmgr_new_log_from_path (f)) != NULL)
+			logview_add_log (logview, tl);
+		else
+			error_dialog_show (NULL, _("Add log error."), log_error());
+	}
+	g_free (f);
 }
 
 static void
 logview_open_log (GtkAction *action, LogviewWindow *logview)
 {
-   static GtkWidget *chooser = NULL;
+	static GtkWidget *chooser = NULL;
 
-   g_assert (LOGVIEW_IS_WINDOW (logview));
+	g_assert (LOGVIEW_IS_WINDOW (logview));
    
-   if (chooser == NULL) {
-	   chooser = gtk_file_chooser_dialog_new (_("Open Log"),
-						  GTK_WINDOW (logview),
-						  GTK_FILE_CHOOSER_ACTION_OPEN,
-						  GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
-						  GTK_STOCK_OPEN, GTK_RESPONSE_OK,
-						  NULL);
-	   gtk_dialog_set_default_response (GTK_DIALOG (chooser), GTK_RESPONSE_OK);
-	   gtk_window_set_modal (GTK_WINDOW (chooser), TRUE);
-	   g_signal_connect (G_OBJECT (chooser), "response",
-			     G_CALLBACK (logview_file_selected_cb), logview);
-	   g_signal_connect (G_OBJECT (chooser), "destroy",
-			     G_CALLBACK (gtk_widget_destroyed), &chooser);
-	   if (prefs_get_active_log () != NULL)
-		   gtk_file_chooser_set_filename (GTK_FILE_CHOOSER (chooser), 
-						  prefs_get_active_log ());
-   }
-
-   gtk_window_present (GTK_WINDOW (chooser));
+	if (chooser == NULL) {
+		chooser = gtk_file_chooser_dialog_new (_("Open Log"),
+						       GTK_WINDOW (logview),
+						       GTK_FILE_CHOOSER_ACTION_OPEN,
+						       GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
+						       GTK_STOCK_OPEN, GTK_RESPONSE_OK,
+						       NULL);
+		gtk_dialog_set_default_response (GTK_DIALOG (chooser), GTK_RESPONSE_OK);
+		gtk_window_set_modal (GTK_WINDOW (chooser), TRUE);
+		g_signal_connect (G_OBJECT (chooser), "response",
+				  G_CALLBACK (logview_file_selected_cb), logview);
+		g_signal_connect (G_OBJECT (chooser), "destroy",
+				  G_CALLBACK (gtk_widget_destroyed), &chooser);
+		if (prefs_get_active_log () != NULL)
+			gtk_file_chooser_set_filename (GTK_FILE_CHOOSER (chooser), 
+						       prefs_get_active_log ());
+	}
+
+	gtk_window_present (GTK_WINDOW (chooser));
 }
 
 static void
 logview_toggle_statusbar (GtkAction *action, LogviewWindow *logview)
 {
-    g_assert (LOGVIEW_IS_WINDOW (logview));
+	g_assert (LOGVIEW_IS_WINDOW (logview));
 
-    if (GTK_WIDGET_VISIBLE (logview->statusbar))
-        gtk_widget_hide (logview->statusbar);
-    else
-        gtk_widget_show (logview->statusbar);
+	if (GTK_WIDGET_VISIBLE (logview->statusbar))
+		gtk_widget_hide (logview->statusbar);
+	else
+		gtk_widget_show (logview->statusbar);
 }
 
 static void
 logview_toggle_sidebar (GtkAction *action, LogviewWindow *logview)
 {
-    g_assert (LOGVIEW_IS_WINDOW (logview));
+	g_assert (LOGVIEW_IS_WINDOW (logview));
 
 	if (GTK_WIDGET_VISIBLE (logview->sidebar))
 		gtk_widget_hide (logview->sidebar);
@@ -560,7 +678,7 @@ logview_toggle_sidebar (GtkAction *action, LogviewWindow *logview)
 static void 
 logview_toggle_calendar (GtkAction *action, LogviewWindow *logview)
 {
-    g_assert (LOGVIEW_IS_WINDOW (logview));
+	g_assert (LOGVIEW_IS_WINDOW (logview));
 
 	if (GTK_WIDGET_VISIBLE (logview->calendar))
 		gtk_widget_hide (logview->calendar);
@@ -576,37 +694,46 @@ logview_toggle_calendar (GtkAction *action, LogviewWindow *logview)
 static void 
 logview_collapse_rows (GtkAction *action, LogviewWindow *logview)
 {
-    g_assert (LOGVIEW_IS_WINDOW (logview));
+	g_assert (LOGVIEW_IS_WINDOW (logview));
 
-    gtk_tree_view_collapse_all (GTK_TREE_VIEW (logview->view));
+	gtk_tree_view_collapse_all (GTK_TREE_VIEW (logview->view));
 }
 
 static void
 logview_toggle_monitor (GtkAction *action, LogviewWindow *logview)
 {
-    Log *log;
-
-    g_assert (LOGVIEW_IS_WINDOW (logview));
-
-    log = logview->curlog;
-    if ((log == NULL) || (log->display_name))
-        return;
+	Log *log;
+	gchar *display_name;
+	gboolean monitoring;
+
+	g_assert (LOGVIEW_IS_WINDOW (logview));
+
+	log = logview->curlog;
+	g_object_get (G_OBJECT (log),
+		      "display-name", &display_name,
+		      "monitoring", &monitoring,
+		      NULL);
+	if ((log == NULL) || display_name) {
+		g_free (display_name);
+		return;
+	}
+	g_free (display_name);
 
-    if (gtk_toggle_action_get_active (GTK_TOGGLE_ACTION (action)) &&
-        (log->monitored))
-        return;
+	if (gtk_toggle_action_get_active (GTK_TOGGLE_ACTION (action)) &&
+	    monitoring)
+		return;
 
-    if (gtk_toggle_action_get_active (GTK_TOGGLE_ACTION (action))==FALSE &&
-        (!log->monitored))
-        return;
+	if (gtk_toggle_action_get_active (GTK_TOGGLE_ACTION (action))==FALSE &&
+	    !monitoring)
+		return;
 
-    if (log->monitored)
-        monitor_stop (log);
-    else
-        monitor_start (log);
+	if (monitoring)
+		monitor_stop (log);
+	else
+		monitor_start (log);
     
-    logview_set_window_title (logview);
-    logview_menus_set_state (logview);
+	logview_set_window_title (logview);
+	logview_menus_set_state (logview);
 }
 
 #define DEFAULT_LOGVIEW_FONT "Monospace 10"
@@ -635,7 +762,7 @@ logview_set_fontsize (LogviewWindow *logview)
 	PangoFontDescription *fontdesc;
 	PangoContext *context;
 	
-    g_assert (LOGVIEW_IS_WINDOW (logview));
+	g_assert (LOGVIEW_IS_WINDOW (logview));
 
 	context = gtk_widget_get_pango_context (logview->view);
 	fontdesc = pango_context_get_font_description (context);
@@ -647,7 +774,7 @@ logview_set_fontsize (LogviewWindow *logview)
 static void
 logview_bigger_text (GtkAction *action, LogviewWindow *logview)
 {
-    g_assert (LOGVIEW_IS_WINDOW (logview));
+	g_assert (LOGVIEW_IS_WINDOW (logview));
 
 	logview->fontsize = MIN (logview->fontsize + 1, 24);
 	logview_set_fontsize (logview);
@@ -656,7 +783,7 @@ logview_bigger_text (GtkAction *action, LogviewWindow *logview)
 static void
 logview_smaller_text (GtkAction *action, LogviewWindow *logview)
 {
-    g_assert (LOGVIEW_IS_WINDOW (logview));
+	g_assert (LOGVIEW_IS_WINDOW (logview));
 
 	logview->fontsize = MAX (logview->fontsize-1, 6);
 	logview_set_fontsize (logview);
@@ -665,7 +792,7 @@ logview_smaller_text (GtkAction *action, LogviewWindow *logview)
 static void
 logview_normal_text (GtkAction *action, LogviewWindow *logview)
 {
-    g_assert (LOGVIEW_IS_WINDOW (logview));
+	g_assert (LOGVIEW_IS_WINDOW (logview));
 
 	logview->fontsize = logview->original_fontsize;
 	logview_set_fontsize (logview);
